
//##################  Variables  ##################
const float4x4 MatWorldViewProj;

//##################  Textures  ##################

const texture DepthTexture : DEPTHMAP;
sampler DepthSample = sampler_state {
    Texture   = <DepthTexture>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

//###############  Input VS  ###############
struct vis {
	float4 Position : POSITION0;
	float2 TexCoords : TEXCOORD0;
};

//###############  Output VS  ##############
struct pis {
	float4 Position : POSITION0;
	float2 TexCoords : TEXCOORD0;
};

//##################  VS  ##################
void vs( in vis IN, out pis OUT ) {
	OUT.Position		= mul(IN.Position,MatWorldViewProj);
	OUT.TexCoords		= IN.TexCoords;
}

//##################  PS  ##################
//===============  Diffuse  ================
float4 psImpScene( in pis IN ) : COLOR {

  float4 Depth = tex2D( DepthSample, IN.TexCoords);		    
	return Depth;    

}


//##############  Technique  ###############
//------------------------------------------
technique MainTechnique {
	pass p0 {	
		vertexshader	= compile vs_2_0 vs();
		pixelshader		= compile ps_2_0 psImpScene();
	}
}

