Include "d:\tools\blitz3d\userlibs\xors3d.bb"




Global ResX = 1024
Global ResY = 768

SeedRnd MilliSecs()

xCreateLog()

; MOUSE
Global MouseSpeed#       = 0.5 
Global CameraSmoothness# = 4.5
Global CamYA#, CamXA#
;/////


; WATER
Global Ratio#
Global WaterRes# = 1024
Global wCamera%
Global tTextureScreen, tTextureReflection
Global OffsetFX#, OffsetFY#
Global OffsetSX#, OffsetSY#
;/////

;xGraphicsAspectRatio(16.0 / 9.0)
xGraphics3D ResX,ResY,32,0,1
xCreateDSS 2048,2048
ResX = xGraphicsWidth()
ResY = xGraphicsHeight()

light = xCreateLight(1)
xRotateEntity light,120,0,0

Global Cam = xCreateCamera()
xCameraClsColor	Cam ,200,200,200
xPositionEntity Cam,0,25,-20


;  Shaders ////////////////////
Global PostProcess_Depth = xLoadPostEffect("depth.fx")
Global Shader_Water = xLoadFXFile("water.fx")

; -- DEPTH
Global DepthTex = xCreateTexture( ResX, ResY, 4096 )
;//////////////////////////////////////////////


sky = xCreateSphere()
xFlipMesh sky
xScaleEntity sky,200,50,200
xEntityColor sky,60,90,150

; -- Water Plane
Dim vx2%(0,0)
Global Water_Plane = CreateTiledPlane(128, 128, 15.0)
xPositionEntity Water_Plane,250,0,250
xEntityAlpha Water_Plane,.99
;//////////////////////////////////////////////

LoadWater(Water_Plane)

palm = xLoadMesh ("palm_01.b3d")
xScaleEntity palm,.5,.5,.5
xPositionEntity palm,0,0,0


Global NoDepth = xCreatePivot()
Global PalmExclude 

CamYA = 20

While Not xKeyHit(1)
	xcls
	If xKeyHit(Key_Space) 
		PalmExclude = 1-PalmExclude
		If PalmExclude
			xEntityParent Palm,NoDepth
		Else
			xEntityParent Palm,0
		EndIf
	EndIf
	
	speed# = .5
	If xKeyDown(42) speed# = 1
	If xKeyDown(KEY_W) Then xMoveEntity Cam,  0,  0,  speed
	If xKeyDown(KEY_S) Then xMoveEntity Cam,  0,  0, -speed
	If xKeyDown(KEY_A) Then xMoveEntity Cam, -speed,  0,  0
	If xKeyDown(KEY_D) Then xMoveEntity Cam,  speed,  0,  0
	mxs# = CurveValue(xMouseXSpeed() * MouseSpeed, mxs, CameraSmoothness)
	mys# = CurveValue(xMouseYSpeed() * MouseSpeed, mys, CameraSmoothness)
	CamXA# = CamXA - mxs Mod 360
	CamYA# = CamYA + mys
	If CamYA < -89 Then CamYA = -89
	If CamYA >  89 Then CamYA =  89
	xMoveMouse xGraphicsWidth() / 2, xGraphicsHeight() / 2
	xRotateEntity Cam, CamYA, CamXA, 0.0
	

	; Scene Depth
	xHideEntity Water_Plane
	xHideEntity NoDepth
	xSetBuffer xTextureBuffer ( DepthTex )
	xSetPostEffect(0, PostProcess_Depth)
	xRenderPostEffects ()
	xShowEntity NoDepth
	;//////////////////////////////////////////
	
	RenderWater Water_Plane,Cam
	
	xSetBuffer xBackBuffer()
	xRenderWorld()
	
	
	xText 10,25*0,"FPS " + xGetFPS()
	xText 10,25*1,"( Space ) Disable depth " + PalmExclude
	xtext 10, 100, ResX + " x " + ResY
	
	xFlip()

Wend




Function LoadWater(tModel%)

	Local tTextureNormalW, tTextureNormalN, Foam
	
	wCamera% = xCreateCamera()
	xCameraRange wCamera, 1 ,10000
	xHideEntity wCamera

	
	; load textures
	tTextureNormalW% = xLoadTexture("Water_NormalW.png")
	tTextureNormalN% = xLoadTexture("Water_NormalN.png")

	
	Ratio# = WaterRes / (Float(ResX)/ResY)
	tTextureReflection% = xCreateTexture( WaterRes, Ratio )
	tTextureScreen%     = xCreateTexture( WaterRes, Ratio )


	Foam = xLoadTexture("Foam.png",2)
	

	; setup shader
	xSetEntityEffect tModel, Shader_Water
	xSetEffectTechnique tModel, "Soft"

	xSetEffectTexture tModel,	"tNormalW", tTextureNormalW
	xSetEffectTexture tModel,	"tNormalN", tTextureNormalN
	
	xSetEffectTexture tModel,"FoamTexture", Foam

	xSetEffectTexture tModel,	"DepthTexture", DepthTex
	xSetEffectTexture tModel,	"tScreen", tTextureScreen
	xSetEffectTexture tModel,	"tReflection", tTextureReflection
	xSetEffectVector tModel,	"TexScale", 0.01, 0.01, 0
	xSetEffectFloat tModel,		"WaterInt", .51
	xSetEffectVector tModel,	"WaterColor", 0,0,0
	xSetEffectFloat tModel,		"FallOffSoft",0.28
	xSetEffectFloat tModel,		"FallOffInt", .3
	xSetEffectFloat tModel,		"Refract", 0
	xSetEffectFloat tModel,		"Reflect", 0.0654
	xSetEffectFloat tModel,		"ViewSoft", 1
End Function 


Function RenderWater(tModel%, gCamera%)

	; update offsets
	OffsetFX = OffsetFX + 0.000640
	OffsetFY = OffsetFY + 0.000655

	OffsetSX = OffsetSX - 0.000645
	OffsetSY = OffsetSY - 0.000665
	; hide objects
	xHideEntity tModel
	xHideEntity gCamera
	xShowEntity wCamera
	
	
	
	

	; Reflection
	xCameraViewport wCamera, 0, 0, WaterRes, Ratio
	ClipPlane wCamera, 0, -0.40, 0, 0, 1, 0, 0, 1 ; -0.299
	xPositionEntity wCamera, xEntityX(gCamera, True),  -xEntityY(gCamera, True), xEntityZ(gCamera, True), True
	xRotateEntity wCamera, -xEntityPitch(gCamera), xEntityYaw(gCamera), -xEntityRoll(gCamera)
	xSetBuffer xTextureBuffer(tTextureReflection)
	xRenderWorld 1,0

	

	xHideEntity wCamera


   
   ClipPlane wCamera, 0, 0, 0, 0, 0, 0, 0, 0

   xSetBuffer xBackBuffer()
   xShowEntity gCamera
   xShowEntity tModel



	; Setting Parameters
	xSetEffectVector tModel,	"OffsetF", OffsetFX, OffsetFY, 0
	xSetEffectVector tModel,	"OffsetS", OffsetSX, OffsetSY, 0
	xSetEffectVector tModel,	"CamPos", xEntityX(gCamera), xEntityY(gCamera), xEntityZ(gCamera)
	

End Function


Function ClipPlane(camera%, x#, y#, z#, vx#, vy#, vz#, index% = 0, enable% = True)
   xCameraClipPlane camera, index, enable, vx, vy, vz, -vx * x - vy * y - vz * z
End Function



Function CreateTiledPlane(cols%, rows%, tileSize# = 1.0)

   Local Mesh%    = xCreateMesh   ()
   Local Surf%    = xCreateSurface(Mesh)
   Local x#    = -(cols*tileSize)/2
   Local y#    = 0
   Local z#    = -(rows*tileSize)/2
   Local u#, v#
   Dim vx2%(cols,rows)

   ; CREATE VERTICES
   i = 0
   For row% = 0 To rows
      For col% = 0 To cols
         y = 0
         u  = col * (uv_scale/cols)
         v  = uv_scale - (row * (uv_scale/rows))
         u = col * (1.0/cols)
         v = 1.0 - (row * (1.0/rows))
         vx2(col,row) = xAddVertex(Surf, x + col*tileSize,y,z + row*tileSize)
         xVertexTexCoords Surf, vx2(col,row), u , v , 1.0, 0 ; UV SET 1
         xVertexTexCoords Surf, vx2(col,row), u , v , 1.0, 1 ; UV SET 2
      Next
   Next

   ; CREATE TRIANGLES
   For row% = 0 To rows-1
      For col% = 0 To cols-1
         xAddTriangle(Surf, vx2(col,row),vx2(col,row+1),vx2(col+1,row+1))
         xAddTriangle(Surf, vx2(col,row),vx2(col+1,row+1),vx2(col+1,row))
      Next
   Next


   
   xUpdateNormals Mesh
   

   Return Mesh

End Function

Function CurveValue#(newvalue#, oldvalue#, increments)
	If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments 
	If increments <= 1 Then oldvalue# = newvalue# 
	Return oldvalue# 
End Function


;~IDEal Editor Parameters:
;~C#Blitz3D